//
// delta-sigma modulator
//

module dsm(clk, rst, value, dsm_out);
    input clk;
    input rst;
    input [11:0] value;
    output reg dsm_out;

  reg [11:0] accu;
  wire [12:0] sum;

  assign sum[12:0] = { 1'b0, value[11:0] } +
                     { 1'b0, accu[11:0] };

  always @(posedge clk) begin
    if (rst) begin
      accu <= 12'h800;
      dsm_out <= 1'b0;
    end else begin
      accu[11:0] <= sum[11:0];
      dsm_out <= sum[12];
    end
  end

endmodule
