//
// sine and slope tables
//

module sine_mem(clk, addr, sine_data, slope_data);
    input clk;
    input [7:0] addr;
    output [15:0] sine_data;
    output [15:0] slope_data;

  wire [9:0] addr1;
  wire [9:0] addr2;

  assign addr1[9:0] = { 2'b00, addr };
  assign addr2[9:0] = { 2'b01, addr };

  RAMB16_S18_S18 sine_slope_mem(
    // sine table port
    .DOA(sine_data),     // 16-bit Data Output
    .ADDRA(addr1),       // 10-bit Address Input
    .CLKA(clk),          // Clock
    .DIA(16'h0000),      // 16-bit Data Input
    .ENA(1'b1),          // RAM Enable Input
    .SSRA(1'b0),         // Synchronous Set/Reset Input
    .WEA(1'b0),          // Write Enable Input
    // slope table port
    .DOB(slope_data),    // 16-bit Data Output
    .ADDRB(addr2),       // 10-bit Address Input
    .CLKB(clk),          // Clock
    .DIB(16'h0000),      // 16-bit Data Input
    .ENB(1'b1),          // RAM Enable Input
    .SSRB(1'b0),         // Synchronous Set/Reset Input
    .WEB(1'b0)           // Write Enable Input
  );

  `include "sine_mem.init"

endmodule
